package cage.carl;

import cage.core.Logger;

import java.util.*;
import java.lang.reflect.Method;

/**
 * Created by IntelliJ IDEA.
 * User: smarinel
 * Date: Oct 6, 2007
 * Time: 7:49:07 PM
 * To change this template use File | Settings | File Templates.
 */
class Builtin extends Closure {

    private static Logger log = Logger.getRootLogger();

    private String name;
    private Method method;

    public Builtin(String name, ArrayList<String> param_names,
                   ArrayList<Closure.ReturnType> param_types,
                   Closure.ReturnType return_type, Method exec)
    {
        //me = b;

        block = null;
        bindings = null;

        this.param_names = param_names;
        this.param_types = param_types;

        method = exec;

        this.name = name;
        returntype = return_type;

    }


    public String getName()
    {
        return name;
    }

    public void execute(HashMap<String, Object> globals)
            throws UnsupportedOperationException
    {
        throw new UnsupportedOperationException();
    }

    public Object execute(HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        Object[] args = new Object[params.size()];

        for (int i = 0; i < params.size(); i++) {
            args[i] = params.get(Integer.toString(i + 1));
        }


        try {
            return method.invoke(null, args);
        } catch (Exception e) {
            log.info(e.getClass() + "   " + e.getMessage());
            log.error("Could not invoke the builtin function " + method.getName());
        }

        return null;
    }

    public static HashMap<String, Object> createBuiltins() {

        Integer count = 1;

        Method[] methods = Mediator.class.getMethods();

        HashMap<String, Object> ret = new HashMap<String, Object>();


        for (Method m : methods) {
            if (m.getDeclaringClass().equals(Mediator.class)) {

                ArrayList<String> p_names = new ArrayList<String>();
                ArrayList<Closure.ReturnType> p_types = new ArrayList<Closure.ReturnType>();

                Closure.ReturnType rt;

                count = 1;

                for (Class c :m.getParameterTypes()) {
                    if (!c.getName().equals("void")) {
                        p_types.add((Closure.getReturnTypeFromClass(c)));
                        p_names.add(count.toString());
                        count++;
                    }
                }

                Class c = m.getReturnType();

                if (c.getName().equals("void")) {
                    rt = Closure.ReturnType.R_NOTHING;
                }
                else {
                    rt = Closure.getReturnTypeFromClass(c);
                }

                log.info(m.getName());
                Logger.setIndent(3);

                for (Closure.ReturnType t : p_types) {
                    log.info("Parameter: " + Closure.getReturnTypeString(t));
                }


                log.info("Return: " + Closure.getReturnTypeString(rt));

                Logger.setIndent(0);

                ret.put(m.getName(), new Builtin(m.getName(), p_names, p_types, rt, m));

            }
        }

        return ret;
    }
}