package cage.carl;

public class Point
{
    public double x;
    public double y;

    public Point()
    {
        x = 0;
        y = 0;
    }
    
    public Point(double a, double b)
    {
        x = a;
        y = b;
    }
    
    public Point(String p)
    {
        int comma = p.indexOf(",");
        Double xd = new Double(p.substring(p.indexOf("<"),comma).trim());
        Double yd = new Double(p.substring(comma,p.indexOf(">")).trim());
        
        x = xd.doubleValue();
        y = yd.doubleValue();
    }
    
    public String toString()
    {
        return "<" + x + "," + y + ">";
    }
    
    public static Point add(Point a, Point b)
    {
        return new Point(a.x + b.x, a.y + b.y);
    }

    public static Point add(Point a, Number b)
    {
        return new Point(a.x + b.doubleValue(), a.y + b.doubleValue());
    }

    public static Point add(Number a, Point b)
    {
        return new Point(b.x + a.doubleValue(), b.y + a.doubleValue());
    }
    
    public static Point sub(Point a, Point b)
    {
        return new Point(a.x - b.x, a.y - b.y);
    }

    public static Point sub(Point a, Number b)
    {
        return new Point(a.x - b.doubleValue(), a.y - b.doubleValue());
    }
    
    public static Point inverse(Point a)
    {
        return new Point(-a.x, -a.y);
    }
    
    public static Point mult(Point a, Point b)
    {
        return new Point(a.x * b.x, a.y * b.y);
    }

    public static Point mult(Point a, Number b)
    {
        return new Point(a.x * b.doubleValue(), a.y * b.doubleValue());
    }

    public static Point mult(Number a, Point b)
    {
        return new Point(b.x * a.doubleValue(), b.y * a.doubleValue());
    }

    public static Point div(Point a, Number b)
    {
        return new Point(a.x / b.doubleValue(), a.y / b.doubleValue());
    }
    
    public static boolean equals(Point a, Point b)
    {
        return (a.x == b.x && a.y == b.y);
    }
}

