package cage.carl;

import java.io.*;
import java.util.*;

class TestCarl
{
    private static void error(String msg)
    {
        System.err.println("TestCarl: " + msg);
        System.exit(1);
    }
    
    private static Object execute_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        try
        {
            return ((Closure)globals.get(test)).execute(globals,params);
        }
        catch (InvalidException e)
        {
            error(e.toString());
        }
        
        return null;
    }
    
    private static boolean bool_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        return ((Boolean)execute_test(test,globals,params)).booleanValue();
    }
    
    private static int int_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        return ((Integer)execute_test(test,globals,params)).intValue();
    }
    
    private static double real_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        return ((Double)execute_test(test,globals,params)).doubleValue();
    }
    
    private static Point point_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        return ((Point)execute_test(test,globals,params));
    }
    
    private static String string_test(String test, HashMap<String,Object> globals, HashMap<String,Object> params)
    {
        return ((String)execute_test(test,globals,params));
    }

    static void action(HashMap<String,Object> globals)
    {
        if (execute_test("test",globals, null) != null)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void boolops(HashMap<String,Object> globals)
    {
        if (!bool_test("test",globals, null))
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (bool_test("test2",globals, null))
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (bool_test("test3",globals, null))
        {
            System.out.println("FAIL 3");
            return;
        }
        
        if (!bool_test("test4",globals, null))
        {
            System.out.println("FAIL 4");
            return;
        }
        
        if (!bool_test("test5",globals, null))
        {
            System.out.println("FAIL 5");
            return;
        }
        
        if (!bool_test("test6",globals, null))
        {
            System.out.println("FAIL 6");
            return;
        }
        
        if (bool_test("test7",globals, null))
        {
            System.out.println("FAIL 7");
            return;
        }
        
        if (!bool_test("test8",globals, null))
        {
            System.out.println("FAIL 8");
            return;
        }
        
        if (!bool_test("test9",globals, null))
        {
            System.out.println("FAIL 9");
            return;
        }
        
        if (bool_test("test10",globals, null))
        {
            System.out.println("FAIL 10");
            return;
        }
        
        if (!bool_test("test11",globals, null))
        {
            System.out.println("FAIL 11");
            return;
        }
        
        if (bool_test("test12",globals, null))
        {
            System.out.println("FAIL 12");
            return;
        }
        
        if (bool_test("test13",globals, null))
        {
            System.out.println("FAIL 13");
            return;
        }
        
        if (!bool_test("test14",globals, null))
        {
            System.out.println("FAIL 14");
            return;
        }
        
        if (!bool_test("test15",globals, null))
        {
            System.out.println("FAIL 15");
            return;
        }
        
        if (!bool_test("test16",globals, null))
        {
            System.out.println("FAIL 16");
            return;
        }
        
        if (bool_test("test17",globals, null))
        {
            System.out.println("FAIL 17");
            return;
        }
        
        if (!bool_test("test18",globals, null))
        {
            System.out.println("FAIL 18");
            return;
        }
        
        if (!bool_test("test19",globals, null))
        {
            System.out.println("FAIL 19");
            return;
        }
        
        if (bool_test("test20",globals, null))
        {
            System.out.println("FAIL 20");
            return;
        }
        
        if (bool_test("test21",globals, null))
        {
            System.out.println("FAIL 21");
            return;
        }
        
        if (!bool_test("test22",globals, null))
        {
            System.out.println("FAIL 22");
            return;
        }
        
        if (!bool_test("test23",globals, null))
        {
            System.out.println("FAIL 23");
            return;
        }
        
        if (bool_test("test24",globals, null))
        {
            System.out.println("FAIL 24");
            return;
        }
        
        if (!bool_test("test25",globals, null))
        {
            System.out.println("FAIL 25");
            return;
        }
        
        if (bool_test("test26",globals, null))
        {
            System.out.println("FAIL 26");
            return;
        }
        
        if (bool_test("test27",globals, null))
        {
            System.out.println("FAIL 27");
            return;
        }
        
        if (!bool_test("test28",globals, null))
        {
            System.out.println("FAIL 28");
            return;
        }
        
        if (bool_test("test29",globals, null))
        {
            System.out.println("FAIL 29");
            return;
        }
        
        if (!bool_test("test30",globals, null))
        {
            System.out.println("FAIL 30");
            return;
        }
        
        if (bool_test("test31",globals, null))
        {
            System.out.println("FAIL 31");
            return;
        }
        
        if (!bool_test("test32",globals, null))
        {
            System.out.println("FAIL 32");
            return;
        }
        
        if (bool_test("test33",globals, null))
        {
            System.out.println("FAIL 33");
            return;
        }
        
        if (!bool_test("test34",globals, null))
        {
            System.out.println("FAIL 34");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void call(HashMap<String,Object> globals)
    {
        if (int_test("test",globals, null) != 1)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (int_test("test2",globals, null) != 2)
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (int_test("test3",globals, null) != 26)
        {
            System.out.println("FAIL 3");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void declares(HashMap<String,Object> globals)
    {
        if (int_test("test",globals, null) != 1)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (real_test("test2",globals, null) != 2.3)
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (!bool_test("test3",globals, null))
        {
            System.out.println("FAIL 3");
            return;
        }
        
        if (!Point.equals(point_test("test4",globals, null), new Point(1,2.3)))
        {
            System.out.println("FAIL 4");
            return;
        }
        
        if (!string_test("test5",globals, null).equals("hello"))
        {
            System.out.println("FAIL 5");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void function(HashMap<String,Object> globals)
    {
        HashMap<String,Object> params = new HashMap<String,Object>();
    
        if (execute_test("test",globals, null) != null)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        params.put("a",new Integer(0));
        if (int_test("test2",globals, params) != 0)
        {
            System.out.println("FAIL 2");
            return;
        }
        
        params.put("a",new Integer(10000));
        if (int_test("test2",globals, params) != 10000)
        {
            System.out.println("FAIL 3");
            return;
        }
        
        params.put("a",new Boolean(true));
        if (!bool_test("test3",globals, params))
        {
            System.out.println("FAIL 4");
            return;
        }
        
        params.put("a",new Boolean(false));
        if (bool_test("test3",globals, params))
        {
            System.out.println("FAIL 5");
            return;
        }
        
        params.put("a",new Double(1.1));
        if (real_test("test4",globals, params) != 1.1)
        {
            System.out.println("FAIL 6");
            return;
        }
        
        params.put("a",new Double(12345.67890123));
        if (real_test("test4",globals, params) != 12345.67890123)
        {
            System.out.println("FAIL 7");
            return;
        }
        
        params.put("a","hello");
        if (!string_test("test5",globals, params).equals("hello"))
        {
            System.out.println("FAIL 8");
            return;
        }
        
        params.put("a",new Point(1,2.3));
        if (!Point.equals(point_test("test6",globals, params), new Point(1,2.3)))
        {
            System.out.println("FAIL 9");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void globals(HashMap<String,Object> globals)
    {
        if (execute_test("setup",globals, null) != null)
        {
            System.out.println("FAIL setup");
            return;
        }
        
        if (!bool_test("test",globals, null))
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (int_test("test2",globals, null) != 1)
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (real_test("test3",globals, null) != 2.3)
        {
            System.out.println("FAIL 3");
            return;
        }
        
        if (!Point.equals(point_test("test4",globals, null), new Point(1,2.3)))
        {
            System.out.println("FAIL 4");
            return;
        }
        
        if (!string_test("test5",globals, null).equals("hello"))
        {
            System.out.println("FAIL 5");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void ifelse(HashMap<String,Object> globals)
    {
        if (!bool_test("test",globals,null))
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (bool_test("test2",globals,null))
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (!bool_test("test3",globals,null))
        {
            System.out.println("FAIL 3");
            return;
        }
        
        if (bool_test("test4",globals,null))
        {
            System.out.println("FAIL 4");
            return;
        }
        
        if (int_test("test5",globals,null) != 1)
        {
            System.out.println("FAIL 5");
            return;
        }
        
        if (int_test("test6",globals,null) != 2)
        {
            System.out.println("FAIL 6");
            return;
        }
        
        if (int_test("test7",globals,null) != 3)
        {
            System.out.println("FAIL 7");
            return;
        }
        
        if (int_test("test8",globals,null) != 6)
        {
            System.out.println("FAIL 8");
            return;
        }
        
        if (int_test("test9",globals,null) != 3)
        {
            System.out.println("FAIL 9");
            return;
        }
        
        if (int_test("test10",globals,null) != 1)
        {
            System.out.println("FAIL 10");
            return;
        }
        
        System.out.println("pass");
    }
    
    static void intops(HashMap<String,Object> globals)
    {
        if (int_test("test",globals,null) != 1)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        if (int_test("test2",globals,null) != -1)
        {
            System.out.println("FAIL 2");
            return;
        }
        
        if (int_test("test3",globals,null) != 3)
        {
            System.out.println("FAIL 3");
            return;
        }
        
        if (int_test("test4",globals,null) != 6)
        {
            System.out.println("FAIL 4");
            return;
        }
        
        if (int_test("test5",globals,null) != 15)
        {
            System.out.println("FAIL 5");
            return;
        }
        
        if (int_test("test6",globals,null) != 1)
        {
            System.out.println("FAIL 6");
            return;
        }
        
        if (int_test("test7",globals,null) != 6)
        {
            System.out.println("FAIL 7");
            return;
        }
        
        if (int_test("test8",globals,null) != 2)
        {
            System.out.println("FAIL 8");
            return;
        }
        
        if (!string_test("test9",globals,null).equals("hello, world"))
        {
            System.out.println("FAIL 9");
            return;
        }
        
        if (!string_test("test9_1",globals,null).equals("hi\n"))
        {
            System.out.println("FAIL 9_1");
            return;
        }
        
        if (!Point.equals(point_test("test10",globals,null), new Point(1,2)))
        {
            System.out.println("FAIL 10");
            return;
        }
        
        if (!Point.equals(point_test("test11",globals,null), new Point(4,6)))
        {
            System.out.println("FAIL 11");
            return;
        }
        
        if (!Point.equals(point_test("test12",globals,null), new Point(-2,-2)))
        {
            System.out.println("FAIL 12");
            return;
        }
        
        if (!Point.equals(point_test("test13",globals,null), new Point(5,6)))
        {
            System.out.println("FAIL 13");
            return;
        }
        
        if (!Point.equals(point_test("test14",globals,null), new Point(5,6)))
        {
            System.out.println("FAIL 14");
            return;
        }
        
        if (!Point.equals(point_test("test15",globals,null), new Point(6,8)))
        {
            System.out.println("FAIL 15");
            return;
        }
        
        if (!Point.equals(point_test("test16",globals,null), new Point(6,8)))
        {
            System.out.println("FAIL 16");
            return;
        }
        
        if (!Point.equals(point_test("test17",globals,null), new Point(1,2)))
        {
            System.out.println("FAIL 17");
            return;
        }
        
        if (!Point.equals(point_test("test18",globals,null), new Point(1.5,2)))
        {
            System.out.println("FAIL 18");
            return;
        }
        
        if (int_test("test19",globals,null) != 1)
        {
            System.out.println("FAIL 19");
            return;
        }
        
        if (real_test("test20",globals,null) != 1.5)
        {
            System.out.println("FAIL 20");
            return;
        }
        
        if (int_test("test21",globals,null) != 5)
        {
            System.out.println("FAIL 21");
            return;
        }
        
        if (int_test("test22",globals,null) != 2)
        {
            System.out.println("FAIL 22");
            return;
        }
        
        if (real_test("test23",globals,null) != 3.3)
        {
            System.out.println("FAIL 23");
        }
        
        if (real_test("test24",globals,null) != 1.1)
        {
            System.out.println("FAIL 24");
        }
        
        if (real_test("test25",globals,null) != 2.2)
        {
            System.out.println("FAIL 25");
        }
		
		if (!Point.equals(point_test("test26",globals, null), new Point(1.2,3.4)))
        {
            System.out.println("FAIL 26");
            return;
        }
    
        System.out.println("pass");
    }
    
    static void twhile(HashMap<String,Object> globals)
    {
        HashMap<String,Object> params = new HashMap<String,Object>();
        
        params.put("a",new Integer(0));
        if (int_test("test",globals,params) != 10)
        {
            System.out.println("FAIL 1");
            return;
        }
                
        params.put("a",new Integer(-10));
        if (int_test("test",globals,params) != 10)
        {
            System.out.println("FAIL 2");
            return;
        }
                
        params.put("a",new Integer(1));
        if (int_test("test",globals,params) != 10)
        {
            System.out.println("FAIL 3");
            return;
        }
                
        params.put("a",new Integer(15));
        if (int_test("test",globals,params) != 15)
        {
            System.out.println("FAIL 4");
            return;
        }
                
        if (int_test("test2",globals,null) != 1)
        {
            System.out.println("FAIL 5");
            return;
        }
    
        System.out.println("pass");
    }
    
    static void comment(HashMap<String,Object> globals)
    {
        if (int_test("test",globals,null) != 1)
        {
            System.out.println("FAIL 1");
            return;
        }
        
        System.out.println("pass");
    }
}