package cage.graphics;

/**
 *  Represents a simple X,Y point as integers.
 * 
 * @author  Seth Marinello
 * @version 1.0 May. 11, 2005
 */

//Version History
//    Version 1.0 - May. 11, 2005 Seth Marinello

//Revision History
//    May. 11, 2005 Seth - Created

public class Point {

   /** The x coord. */
   public int x;
   
   /** The y coord. */
   public int y;


   /**
    * Instantiates a new point.
    */
   public Point() {
      x = 0;
      y = 0;
   }

   /**
    * Instantiates a new point with given X, Y values.
    * 
    * @param x the x
    * @param y the y
    */
   public Point(int x, int y) {
      this.x = x;
      this.y = y;
   }


    /**
     * Sets the x.
     * 
     * @param xCoord the new x
     */
    public void setX(int xCoord) {
        this.x = xCoord;
    }

    /**
     * Sets the y.
     * 
     * @param yCoord the new y
     */
    public void setY(int yCoord) {
        this.y = yCoord;
    }

    /**
     * Gets the x.
     * 
     * @return the x
     */
    public int getX() {
      return x;
   }

   /**
    * Gets the y.
    * 
    * @return the y
    */
   public int getY() {
      return y;
   }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return "<" + x + "," + y + ">";
    }
}