package cage.graphics;

import org.minueto.image.MinuetoImage;

/**
 * The Interface VisualItem represents something that can be displayed on screen.
 * In Cage this is an Image or Animation.
 */
public interface VisualItem {

    /**
     * Scale.
     * 
     * @param xScale the x scale
     * @param yScale the y scale
     */
    public void scale(double xScale, double yScale);

    /**
     * Gets the name.
     * 
     * @return the name
     */
    public String getName();

    /**
     * Gets the image.
     * 
     * @return the image
     */
    public MinuetoImage getImage();

    /**
     * Gets the width.
     * 
     * @return the width
     */
    public int getWidth();

    /**
     * Gets the height.
     * 
     * @return the height
     */
    public int getHeight();

}
