/*
 * @(#)MinuetoKeyboard.java
 *
 * Minueto - The Game Development Framework 
 * Copyright (c) 2004 McGill University
 * 3480 University Street, Montreal, Quebec H3A 2A7
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.minueto.handlers;

/**
 * The <code>MinuetoKeyboard</code> class contains the set of constants returned by 
 * <code>MinuetoKeyboardHandler</code>. Instead of evaluating key values as integers,
 * the following constants should be used.
 *
 * @author	Alexandre Denault
 * @version 1.0
 * @since 	Minueto 0.4
 * @see 		MinuetoKeyboardHandler
 **/
public class MinuetoKeyboard {

	/** The A key */
	public static final int KEY_A = 65;
	/** The B key */
	public static final int KEY_B = 66;
	/** The C key */
	public static final int KEY_C = 67;
	/** The D key */
	public static final int KEY_D = 68;
	/** The E key */
	public static final int KEY_E = 69;
	/** The F key */
	public static final int KEY_F = 70;
	/** The G key */
	public static final int KEY_G = 71;
	/** The H key */
	public static final int KEY_H = 72;
	/** The I key */
	public static final int KEY_I = 73;
	/** The J key */
	public static final int KEY_J = 74;
	/** The K key */
	public static final int KEY_K = 75;
	/** The L key */
	public static final int KEY_L = 76;
	/** The M key */
	public static final int KEY_M = 77;
	/** The N key */
	public static final int KEY_N = 78;
	/** The O key */
	public static final int KEY_O = 79;
	/** The P key */
	public static final int KEY_P = 80;
	/** The Q key */
	public static final int KEY_Q = 81;
	/** The R key */
	public static final int KEY_R = 82;
	/** The S key */
	public static final int KEY_S = 83;
	/** The T key */
	public static final int KEY_T = 84;
	/** The U key */
	public static final int KEY_U = 85;
	/** The V key */
	public static final int KEY_V = 86;
	/** The W key */
	public static final int KEY_W = 87;
	/** The X key */
	public static final int KEY_X = 88;
	/** The Y key */
	public static final int KEY_Y = 89;
	/** The Z key */
	public static final int KEY_Z = 90;
	
	/** The 1 key on the top of the keyboard */
	public static final int KEY_1 = 49;
	/** The 2 key on the top of the keyboard */
	public static final int KEY_2 = 50;
	/** The 3 key on the top of the keyboard */
	public static final int KEY_3 = 51;
	/** The 4 key on the top of the keyboard */
	public static final int KEY_4 = 52;
	/** The 5 key on the top of the keyboard */
	public static final int KEY_5 = 53;
	/** The 6 key on the top of the keyboard */
	public static final int KEY_6 = 54;
	/** The 7 key on the top of the keyboard */
	public static final int KEY_7 = 55;
	/** The 8 key on the top of the keyboard */
	public static final int KEY_8 = 56;
	/** The 9 key on the top of the keyboard */
	public static final int KEY_9 = 57;
	/** The 0 key on the top of the keyboard */
	public static final int KEY_0 = 48;
	
	/** The Capslock key */
	public static final int KEY_CAPSLOCK = 20;
	/** The Shift key */
	public static final int KEY_SHIFT = 16;
	/** The Control key */
	public static final int KEY_CONTROL = 17;
	/** The Alt key */
	public static final int KEY_ALT = 18;
	/** The Enter key */
	public static final int KEY_ENTER = 10;
	
	/** The Backspace key */
	public static final int KEY_BACKSPACE = 8;
	
	/** The Spacebar key */
	public static final int KEY_SPACE = 32;
	
	/** The Up key */
	public static final int KEY_UP = 38;
	/** The Down key */
	public static final int KEY_DOWN = 40;
	/** The Left key */
	public static final int KEY_LEFT = 37;
	/** The Right key */
	public static final int KEY_RIGHT = 39;
	
	/** The Delete key */
	public static final int KEY_DELETE = 8;
	/** The ESC key */
	public static final int KEY_ESC = 27;
	
	/** The 1 key on the numeric keypad */
	public static final int KEY_NUM_1 = 97;
	/** The 2 key on the numeric keypad */
	public static final int KEY_NUM_2 = 98;
	/** The 3 key on the numeric keypad */
	public static final int KEY_NUM_3 = 99;
	/** The 4 key on the numeric keypad */
	public static final int KEY_NUM_4 = 100;
	/** The 5 key on the numeric keypad */
	public static final int KEY_NUM_5 = 101;
	/** The 6 key on the numeric keypad */
	public static final int KEY_NUM_6 = 102;
	/** The 7 key on the numeric keypad */
	public static final int KEY_NUM_7 = 103;
	/** The 8 key on the numeric keypad */
	public static final int KEY_NUM_8 = 104;
	/** The 9 key on the numeric keypad */
	public static final int KEY_NUM_9 = 105;
	/** The 0 key on the numeric keypad */
	public static final int KEY_NUM_0 = 96;
	
	/** The F1 key */
	public static final int KEY_F1 = 112;
	/** The F2 key */
	public static final int KEY_F2 = 113;
	/** The F3 key */
	public static final int KEY_F3 = 114;
	/** The F4 key */
	public static final int KEY_F4 = 115;
	/** The F5 key */
	public static final int KEY_F5 = 116;
	/** The F6 key */
	public static final int KEY_F6 = 117;
	/** The F7 key */
	public static final int KEY_F7 = 118;
	/** The F8 key */
	public static final int KEY_F8 = 119;
	/** The F9 key */
	public static final int KEY_F9 = 120;
	/** The F10 key */
	public static final int KEY_F10 = 121;
	/** The F11 key */
	public static final int KEY_F11 = 122;
	/** The F12 key */
	public static final int KEY_F12 = 123;
	
	/** The Page Up key */
	public static final int KEY_PAGEUP = 33;
	/** The Page Down key */
	public static final int KEY_PAGEDOWN = 34;
	/** The End key */
	public static final int KEY_END = 35;
	/** The Home key */
	public static final int KEY_HOME = 36;
	
	
	private MinuetoKeyboard() {
		/* This object should never be created. */	
	}
	
}
